> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Get record history

> Retrieve the change history of a specific record, including field modifications and user information.



## OpenAPI

````yaml /swagger.json get /table/{tableId}/record/{recordId}/history
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
paths:
  /table/{tableId}/record/{recordId}/history:
    get:
      tags:
        - record
      summary: Get record history
      description: >-
        Retrieve the change history of a specific record, including field
        modifications and user information.
      parameters:
        - schema:
            type: string
          required: true
          name: tableId
          in: path
        - schema:
            type: string
          required: true
          name: recordId
          in: path
      responses:
        '200':
          description: Get the history list for a record
          content:
            application/json:
              schema:
                type: object
                properties:
                  historyList:
                    type: array
                    items:
                      type: object
                      properties:
                        id:
                          type: string
                        tableId:
                          type: string
                        recordId:
                          type: string
                        fieldId:
                          type: string
                        before:
                          type: object
                          properties:
                            meta:
                              type: object
                              properties:
                                name:
                                  type: string
                                  description: >-
                                    The name of the field. can not be duplicated
                                    in the table.
                                  example: Tags
                                type:
                                  type: string
                                  enum:
                                    - singleLineText
                                    - longText
                                    - user
                                    - attachment
                                    - checkbox
                                    - multipleSelect
                                    - singleSelect
                                    - date
                                    - number
                                    - rating
                                    - formula
                                    - rollup
                                    - conditionalRollup
                                    - link
                                    - createdTime
                                    - lastModifiedTime
                                    - createdBy
                                    - lastModifiedBy
                                    - autoNumber
                                    - button
                                  description: The field types supported by teable.
                                  example: singleSelect
                                cellValueType:
                                  type: string
                                  enum:
                                    - string
                                    - number
                                    - boolean
                                    - dateTime
                                  description: The cell value type of the field.
                                isLookup:
                                  type: boolean
                                  description: >-
                                    Whether this field is lookup field. witch
                                    means cellValue and [fieldType] is looked up
                                    from the linked table.
                                isConditionalLookup:
                                  type: boolean
                                  description: >-
                                    Whether this lookup field applies a
                                    conditional filter when resolving linked
                                    records.
                                options:
                                  nullable: true
                              required:
                                - name
                                - type
                                - cellValueType
                            data:
                              nullable: true
                          required:
                            - meta
                        after:
                          type: object
                          properties:
                            meta:
                              type: object
                              properties:
                                name:
                                  type: string
                                  description: >-
                                    The name of the field. can not be duplicated
                                    in the table.
                                  example: Tags
                                type:
                                  type: string
                                  enum:
                                    - singleLineText
                                    - longText
                                    - user
                                    - attachment
                                    - checkbox
                                    - multipleSelect
                                    - singleSelect
                                    - date
                                    - number
                                    - rating
                                    - formula
                                    - rollup
                                    - conditionalRollup
                                    - link
                                    - createdTime
                                    - lastModifiedTime
                                    - createdBy
                                    - lastModifiedBy
                                    - autoNumber
                                    - button
                                  description: The field types supported by teable.
                                  example: singleSelect
                                cellValueType:
                                  type: string
                                  enum:
                                    - string
                                    - number
                                    - boolean
                                    - dateTime
                                  description: The cell value type of the field.
                                isLookup:
                                  type: boolean
                                  description: >-
                                    Whether this field is lookup field. witch
                                    means cellValue and [fieldType] is looked up
                                    from the linked table.
                                isConditionalLookup:
                                  type: boolean
                                  description: >-
                                    Whether this lookup field applies a
                                    conditional filter when resolving linked
                                    records.
                                options:
                                  nullable: true
                              required:
                                - name
                                - type
                                - cellValueType
                            data:
                              nullable: true
                          required:
                            - meta
                        createdTime:
                          type: string
                        createdBy:
                          type: string
                      required:
                        - id
                        - tableId
                        - recordId
                        - fieldId
                        - before
                        - after
                        - createdTime
                        - createdBy
                  userMap:
                    type: object
                    additionalProperties:
                      type: object
                      properties:
                        email:
                          type: string
                        avatar:
                          type: string
                          nullable: true
                        id:
                          type: string
                        name:
                          type: string
                      required:
                        - email
                        - avatar
                        - id
                        - name
                  nextCursor:
                    type: string
                    nullable: true
                required:
                  - historyList
                  - userMap
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request GET \
              --url https://app.teable.ai/api/table/%7BtableId%7D/record/%7BrecordId%7D/history \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'
        - lang: JavaScript
          source: >-
            const url =
            'https://app.teable.ai/api/table/%7BtableId%7D/record/%7BrecordId%7D/history';

            const options = {method: 'GET', headers: {Authorization: 'Bearer
            REPLACE_BEARER_TOKEN'}};


            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: |-
            const http = require('https');

            const options = {
              method: 'GET',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/table/%7BtableId%7D/record/%7BrecordId%7D/history',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN'
              }
            };

            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });

            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            headers = { 'Authorization': "Bearer REPLACE_BEARER_TOKEN" }


            conn.request("GET",
            "/api/table/%7BtableId%7D/record/%7BrecordId%7D/history",
            headers=headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````